/* GTK Napster-0.1 BETA 4
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#ifndef _NAPSTER_H_
#define _NAPSTER_H_

#include <time.h>
#include <stdio.h>
#include <gtk/gtk.h>

#define TITLEBAR_MAIN 						"GTK Napster-0.201"

#define DIALOG_ERROR 		1
#define DIALOG_WARNING 	2
#define DIALOG_WHOIS 		3
#define DIALOG_ABOUT 		4

#define LINE_SPEED_T3 				"T3 (or greater)"
#define LINE_SPEED_T1 				"T1"
#define LINE_SPEED_DSL 				"DSL"
#define LINE_SPEED_CABLE 			"Cable"
#define LINE_SPEED_ISDN128 		"ISDN-128k"
#define LINE_SPEED_ISDN56 		"ISDN-56k"
#define LINE_SPEED_56MODEM 		"56k Modem"
#define LINE_SPEED_33MODEM 		"33.6 Modem"
#define LINE_SPEED_28MODEM 		"28.8 Modem"
#define LINE_SPEED_14MODEM 		"14.4 Modem"
#define LINE_SPEED_UNKNOWN 		"Unknown"

#define COLUMN_FILENAME 					"Filename"
#define COLUMN_FILESIZE 					"Filesize"
#define COLUMN_PROGRESS 					"Progress"
#define COLUMN_USER 							"User"
#define COLUMN_LINESPEED 					"Line Speed"
#define COLUMN_STATUS 						"Status"
#define COLUMN_SONGS 							"Songs"
#define COLUMN_SPEED 							"Speed"
#define COLUMN_BITRATE 						"Bitrate"
#define COLUMN_FREQ 							"Freq"
#define COLUMN_LENGTH 						"Length"

#define PRIVATE_CHAT_WINDOW 		"Private"

typedef struct gtk_search_window
{
	GtkWidget *search_for_entry;
	GtkWidget *max_results_entry;
	GtkWidget *linespeed_combo;
	GtkWidget *bitrate_combo;
	GtkWidget *freq_combo;
	GtkWidget *linespeed_crit;
	GtkWidget *bitrate_crit;
	GtkWidget *freq_crit;
} gtk_search_window;

typedef struct gtk_chat_window
{
	GtkWidget *ctext;
	GtkWidget *cmsg;
	GtkWidget *clist;
	gchar name[20];
} gtk_chat_window;

typedef struct gtk_hotlist_window
{
	GtkWidget *clist;
	GtkWidget *onlinelist;
	GtkWidget *offlinelist;
	GList *selection;
	gint user_sel;
} gtk_hotlist_window;

typedef struct gtk_pixmap_sess
{
	GdkBitmap *bm_red;
	GdkPixmap *pm_red;
	GdkBitmap *bm_green;
	GdkPixmap *pm_green;
	GdkBitmap *bm_gold;
	GdkPixmap *pm_gold;
} gtk_pixmap_sess;

typedef struct gtk_sess
{
	GtkWidget *window;
	gchar username[20];
	gchar password[20];
	gchar email[100];
	gchar directory[100];
	gchar exec_player[150];
	gint speed;
	gint timeout;
	gboolean CONNECTED;
	gboolean SHOW_TABS;
	gboolean SHOW_BYTE;
	gboolean SHOW_DHMS;
	gboolean PASSWORD;
	gboolean SWITCH_TRANSFER;
	gboolean AUTO_CONNECT;
	gint sockfd;
	gint sockid;
	GtkWidget *statusbar;
	GtkWidget *clist;
	GtkWidget *login_dialog;
	GtkWidget *login_label;
	GtkWidget *page;
	GList *current_sel;
	gint transfer_current_sel;
	GtkWidget *transfer_list;
	GtkWidget *notebook;
	gint nr_chatwins;
	gtk_chat_window *chatwins;
	gtk_search_window search;
	gtk_hotlist_window hotlist;
	gtk_pixmap_sess pixmaps;
} gtk_sess;

typedef struct gtk_dl_sess
{
	gtk_sess *sess;
	gint socketid;
	gint socketfd;
	glong size;
	glong current;
	gint lastpercent;
	time_t start_time;
	FILE *stream;
} gtk_dl_sess;

void get_user_info(gtk_sess *sess);
gchar *make_file(gchar *in);

gchar *make_text_size(glong size);
gchar *make_text_time(glong size, gboolean STYLE);

GtkWidget *make_pixmapwid(GtkWidget *parent, gchar *name[]);

void about_napster(GtkWidget *widget, gpointer data);

gboolean seperate_string(gchar *instr, gchar **outlist, gint nr);

void add_hl_dialog(GtkWidget *widget, gpointer data);

void cancel_download(GtkWidget *widget, gpointer data);
void clear_transfer(GtkWidget *widget, gpointer data);
void play_file(GtkWidget *widget, gpointer data);

void change_to_transfer(GtkWidget *widget, gpointer data);
void change_to_chat(GtkWidget *widget, gpointer data);
void change_to_search(GtkWidget *widget, gpointer data);
void change_to_hotlist(GtkWidget *widget, gpointer data);

void gtk_message_ok(gchar *message, gchar *title, gint type);
void connect_dialog(GtkWidget *widget, gpointer data);
void disconnect_napster(GtkWidget *widget, gpointer data);
void settings_dialog(GtkWidget *widget, gpointer data);

void selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void transfer_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void transfer_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);

void command_hotlist_nofiles(gtk_sess *sess, gchar *instr);
void command_hotlist_results(gtk_sess *sess, gchar *instr);
void command_hotlist_online(gtk_sess *sess, gchar *instr);
void command_hl_useradd(gtk_sess *sess, gchar *username);
void hl_send_logon_request(GtkWidget *widget, gpointer data);
void remove_hl_dialog(GtkWidget *widget, gpointer data);

void get_file_ok(gtk_sess *sess, gchar *instr);

void get_file(GtkWidget *w, gpointer data);
void get_file_hl(GtkWidget *w, gpointer data);

GtkWidget *make_hotlist_page(gtk_sess *sess);

void ReadRCFile(gtk_sess *sess);
void WriteRCFile(gtk_sess *sess);

void destroy(GtkWidget *w, gpointer data);
void make_chat_box(gtk_sess *sess, gchar *name, gint list);
gint get_chat_box_nr(gtk_sess *sess, gchar *name);

gchar *get_speed(gint speed);
gint get_speed_nr(gchar *in);

gboolean napster_connect(gtk_sess *sess, gboolean newuser, gboolean *LOCK, gboolean *CANCEL);

GtkWidget *make_menu(gtk_sess *sess);

void napster_something_to_read(gpointer data, gint source, GdkInputCondition condition); 
gint send_string(gtk_sess *sess, gchar *instr, gint16 code);

void read_command_run(gtk_sess *sess, gint code, gchar *instr);
void string_out(GtkWidget *widget, gchar *instr, gint red, gint green, gint blue);

void command_do_search(GtkWidget *w, gpointer data);
void read_command(GtkWidget *widget, gpointer data);

#endif